$(function() {
    $('form').on('nested:fieldAdded', function(event) {
        $(event.target).find(':input').enableClientSideValidations();
    });

    /*
    * This class has a lot of redundant code which
    * will be cleaned up later on. Especially for the validation
    * and AJAX callbacks.
    */

    var hintCounter = 0;

    //  Helper functions
    function disable(object) {
        object.click(function(e) {
            e.preventDefault();
            e.stopPropagation();
        });
    }

    function answerResponse(answer) {
        var responseContainer = $('#answer-response');
        var response = '';

        if(answer.status > 0) {
            responseContainer.addClass('alert-success');
            response = 'riktig! Hurra!';

            // Fast frontend-fixes
            $('.selected').addClass('completed')
            $('.selected').removeClass('selected')

        }
        else {
            responseContainer.addClass('alert-error');
            response = 'feil :(';
        }

        responseContainer.html('<div>'+answer.answer+' er '+response+'</div>');
    }

    $('#answer')
        .bind("ajax:beforeSend", function(evt, xhr, settings){

		    if ($('#answer-response').length == 0) {
			    var task = $('<div/>', {
				    id: 'answer-response',
				    class: 'alert'
			    }).prependTo($('form'));
		    }

            var $submitButton = $(this).find('input[name="commit"]');
            var $answer = $(this).find('input[type=text]');

            // simple validation: make sure the user has written something in the answer input field
            if($answer.val() == "") {
                $answer.parents('div.control-group').addClass('error');
                return false
            }

            // Update the text of the submit button to let the user know stuff is happening.
            // But first, store the original text of the submit button, so it can be restored when the request is finished.
            $submitButton.attr('data-name', $submitButton.val());
            $submitButton.val( "Sender inn..." );

		    $('#answer-response').removeClass('alert-error').removeClass('alert-success').html('<i class="icon-spinner icon-spin icon-large"></i>');
        })

        .bind("ajax:success", function(evt, data, status, xhr){
            var $form = $(this);

            // Reset fields and any validation errors, so form can be used again, but leave hidden_field values intact.
            $form.find('textarea,input[type="text"],input[type="file"]').val("");
            $form.find('div#validation-errors').empty();

            // Insert response partial into page below the form.
            answerResponse(data);
        })

        .bind('ajax:complete', function(evt, xhr, status){
            var $submitButton = $(this).find('input[name="commit"]');
            var $answer = $(this).find('input[type=text]');

            // Restore the original submit button text
            $submitButton.val( $submitButton.attr('data-name'));
            $answer.parents('div.control-group').removeClass('error');
        })

        .bind("ajax:error", function(evt, xhr, status, error){
            var $form = $(this),
                errors,
                errorText;

            try {
                // Populate errorText with the comment errors
                errors = $.parseJSON(xhr.responseText);
            } catch(err) {
                // If the responseText is not valid JSON (like if a 500 exception was thrown), populate errors with a generic error message.
                errors = {message: "Vennligst last inn siden på nytt"};
            }

            // Build an unordered list from the list of errors
            errorText = "There were errors with the submission: \n<ul>";

            for ( error in errors ) {
                errorText += "<li>" + error + ': ' + errors[error] + "</li> ";
            }

            errorText += "</ul>";

            // Insert error list into form
            $form.find('div.validation-error').html(errorText);
        });

    $('.hint-btn').bind('ajax:success', function(event, data) {
        $('#hint-container').append('<div class="hint well">'+data.text+'</div>');
        hintCounter++;
        if (data.last) {
            $(this).text('All hints shown').addClass('disabled');
            disable($(this));
        }
    });

    $('.hint-btn').bind('ajax:before', function() {
        $(this).data('params', { hint: hintCounter });
    });
});