class AnswersController < ApplicationController

  def answer
    @task = Task.find(params[:task_id])
    @answer = @task.answers.find_by_user_id(current_user.id)

    @answer.answer = params[:answer][:answer]

    if @answer.status < 2
      # the user has not yet completed the task, so the answer will
      # still be updated in the database.
      if @answer.correct?
        @answer.status = 1
        current_user.update_progression(@task.skill)
      else
        @answer.attempts = @answer.attempts + 1
      end
      @answer.save
    end

    @answer.status = 0 unless @answer.correct?

    respond_to do |format|
      format.json {render :json => @answer}
    end
  end

  def show
    @answer = Answer.find(params[:id])
    respond_to do |format|
      format.json { render :json => {:success => true, :html => (render_to_string '_answer.html.erb')}}
    end
  end

end