class SchoolClassesController < ApplicationController
  before_filter :authenticate_user!
  load_and_authorize_resource

  def index
    @school_classes = SchoolClass.all
  end

  def new
    @school_class = SchoolClass.new
  end

  def create
    @school_class = SchoolClass.new(params[:school_class])
    if @school_class.save
      redirect_to @school_class
    else
      render :action => 'new'
    end
  end

  def show
    @school_class = SchoolClass.find(params[:id])
  end

  def edit
    @school_class = SchoolClass.find(params[:id])
  end

  def update
    @school_class = SchoolClass.find(params[:id])
    begin
    if @school_class.update_attributes(params[:school_class])
      redirect_to @school_class
    else
      render :action => 'edit'
    end
    rescue
      # stealing students raised
      flash[:error] = 'Studenten(e) er registrert i en annen klasse'
      render :action => 'edit'
    end
  end

end