class SkillsController < ApplicationController
  before_filter :authenticate_user!
  load_and_authorize_resource

  def new
    @skill = Skill.new(:parent_id => params[:parent_id])
  end

  def index
    @skills = Skill.roots
    begin
      @subject = Subject.find(params[:subject_id])
    rescue
      @subject = nil
    end
  end

  # called through AJAX
  def add_subject
    skill = Skill.find(params[:id])
    subject = Subject.find(params[:subject_id])
    skill.subjects << subject

    respond_to do |format|
      #todo: proper AJAX response
      format.js {render :nothing => true}
    end
  end

  def show
    @skill = Skill.find(params[:id])
  end

  def create
    @skill = Skill.new(params[:skill])
    if @skill.save
      redirect_to @skill
    else
      render :action => "new"
    end
  end

  def edit
    @skill = Skill.find(params[:id])
  end

  def update
    @skill = Skill.find(params[:id])
    if @skill.update_attributes(params[:skill])
      redirect_to @skill
    else
      render :action => 'edit'
    end
  end

  def destroy
    @skill = Skill.find(params[:id])
    @skill.destroy
    redirect_to skills_url
  end
end
