class SubjectsController < ApplicationController
  before_filter :authenticate_user!
#  load_and_authorize_resource

  def new
    @subject = Subject.new
  end

  def show
    @subject = Subject.find(params[:id])
    @skills = @subject.root_skills

    respond_to do |format|
      format.html
      format.json {render :json => @subject.skills}
    end
  end

  def create
    @subject = Subject.new(params[:subject])
    if @subject.save
      redirect_to @subject
    else
      render :action => "new"
    end
  end

  def practice
    @subjects = current_user.school_class.subjects
    render 'index'
  end

  def index
     @subjects = Subject.all
  end

  def edit
    @subject = Subject.find(params[:id])
  end

  def destroy
    @subject = Subject.find(params[:id])
    @subject.destroy

    redirect_to subjects_path
  end

  def update
    subject = Subject.find(params[:id])

    respond_to do |format|
      if subject.update_attributes(params[:subject])
        format.html { redirect_to subject_url }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @subject.errors, status: :unprocessable_entity }
      end
    end
  end
end
