class TasksController < ApplicationController
  before_filter :authenticate_user!
#  load_and_authorize_resource

  def new
    @skill = Skill.find(params[:skill_id])
    @task =  @skill.tasks.new
  end

  def show
    @task = Task.find(params[:id])

    # additional attributes can be added as virtual attributes
    respond_to do |format|
      # AJAX call
      format.json {render :json => @task}
      format.html
    end

  end

  def edit
    @skill = Skill.find(params[:skill_id])
    @task =  @skill.tasks.find(params[:id])
  end

  def update
    @skill = Skill.find(params[:skill_id])
    @task = @skill.tasks.find(params[:id])
    if @task.update_attributes(params[:task])
      flash[:notice] = 'Task updated'
      redirect_to skill_task_path(@skill, @task)
    else
      render :action => 'edit'
    end
  end

  def index
    # listing all tasks, for CRUD purposes
    # called through AJAX in User#show
    @skill = Skill.find(params[:skill_id])
    @tasks = @skill.tasks.all
  end

  # AJAX call to get hints for the current task
  def show_hint
    @task = Task.find(params[:id])
    hint_no = Integer(params[:hint])

    answer = @task.answers.find_by_user_id(current_user.id)

    @hint = @task.hints[hint_no]
    answer.use_hint(hint_no)
    @hint == @task.hints.last ? @hint.last = true : @hint.last = false

    respond_to do |format|
      format.json {render :json => @hint.to_json(:methods => %w(last))}
    end

  end

  def answer
    skill = Skill.find(params[:skill_id])
    @task = skill.tasks.find(params[:id])
    @answer = @task.first_attempt?(current_user)
    @skill = skill
    if @answer.nil?
      # first attempt
      @answer = @task.add_answer(current_user) if @answer.nil?
    else
      @answer.prep
    end
  end

  def create
    @skill = Skill.find(params[:skill_id])
    @task =  @skill.tasks.create(params[:task])

    if @task.save
      redirect_to skill_task_path(@skill, @task)
    else
      render :action => 'new'
    end
  end

  def destroy
    @task = Task.find(params[:id])
    @task.destroy

    redirect_to skill_path(@task.skill)
  end


end
