class UsersController < ApplicationController
  before_filter :authenticate_user!

  def index
    @users = User.all
  end

  def show
    @user = User.find(params[:id])
  end

  def summary
    @user = User.find(params[:id])
    respond_to do |format|
      format.json { render :json => {:success => true, :html => (render_to_string 'users/profile/_summary.html.erb')}}
    end
  end

  # in order to save processing time, initially only root nodes are fetched, which is indicated by
  # the ROOT parameter added to the URL.
  def skills
    @user = User.find(params[:id])
    if params[:root]
      @skills = []
      @user.skill_progressions.each do |progression|
          @skills << progression.skill if progression.skill.is_root?
      end
    else
      @skills = Skill.find(params[:parent_id]).children
    end

    respond_to do |format|
      format.json { render :json => {:success => true, :html => (render_to_string 'users/profile/_skills.html.erb')}}
    end
  end

  def achievements
    @user = User.find(params[:id])
    respond_to do |format|
      format.json { render :json => {:success => true, :html => (render_to_string 'users/profile/_achievements.html.erb')}}
    end
  end

  def edit
    @user = User.find(params[:id])
    respond_to do |format|
      format.json { render :json => {:success => true, :html => (render_to_string 'users/_form.html.erb')}}
    end
  end

  def update
    @user = User.find(params[:id])
    respond_to do |format|
      if @user.update_attributes(params[:user])
        format.json {render :json => @user}
        format.html { redirect_to user_url }
      else
        format.json { render json: @user.errors, status: :unprocessable_entity }
        format.html { render action: "edit" }
      end
    end
  end

end
