# Be sure to restart your server when you modify this file.
#
# Points are a simple integer value which are given to "meritable" resources
# according to rules in +app/models/merit/point_rules.rb+. They are given on
# actions-triggered, either to the action user or to the method (or array of
# methods) defined in the +:to+ option.
#
# 'score' method may accept a block which evaluates to boolean
# (receives the object as parameter)

module Merit
  class PointRules
    include Merit::PointRulesMethods

    def initialize

      # Rule for giving points for completing tasks
      # Since score is a symbol (check made in judge.rb), merit will use the associated task.points for scoring
      score :points, :on => 'answers#answer' do |answer|
        answer.points? && Merit::RankRules.new.check_rank_rules
      end

      # Rule for giving points when completing skills
      score 100, :on => 'answers#answer' do |answer|
        answer.user.completed_skill?(answer.task.skill) && answer.user.skill_progressions.find_by_skill_id(answer.task.skill.id).points?
      end

    end
  end
end
