Academy::Application.routes.draw do

  authenticated :user do
    root :to => 'home#index'
  end

  root :to => "home#index"

  devise_for :users

  resources :skills do
    member do
      post 'add_subject/:subject_id', :action => 'add_subject', :as => 'add_subject'
    end
    resources :tasks, :except => :index do
      member do
        post 'show_hint'
        get 'answer'
      end
      match 'answer' => 'answers#answer', :via => :post
    end
  end

  resources :subjects, :shallow => true do
    collection do
      get 'practice'
    end
    resources :skills, :only => :index
  end

  resources :users do
    member do
      get 'summary'
      get 'skills'
      get 'achievements'
    end
    resources :answers, :only => :show
    resources :skill_progressions, :only => :show
  end

  resources :school_classes, :path => 'classes'

end
