class AddTables < ActiveRecord::Migration
  def up
    create_table(:subjects) do |t|
      t.string :name, :null => false

      t.timestamps
    end

    create_table(:skills) do |t|
      t.string :name, :null => false

      t.timestamps
    end

    create_table(:tasks) do |t|
      t.string :name, :null => false
      t.integer :points, :null => false
      t.string :solution, :null => false
      t.string :question, :null => false
      t.references :skill

      t.timestamps
    end

    create_table(:hints) do |t|
      t.string :text, :null => false
      t.references :task

      t.timestamps
    end

    create_table :skill_progressions do |t|
      t.integer :status
      t.float :progress
      t.references :skill
      t.references :user

      t.timestamps
    end

    create_table :answers do |t|
      t.integer :status
      t.string :answer
      t.integer :hints_used
      t.integer :attempts
      t.references :task
      t.references :user

      t.timestamps
    end

    create_table :school_classes do |t|
      t.integer :year
      t.string :name
      t.integer 'teacher_id'
    end

    create_table :class_subjects, :id => false do |t|
      t.references :school_class
      t.references :subject
    end


    create_table :skills_subjects, :id => false do |t|
      t.references :skill
      t.references :subject

      t.timestamps
    end

  end

  def down
  end
end
