class AddRoles < ActiveRecord::Migration
  def up
    create_table :roles do |t|
      t.string :name
      t.timestamps
    end

    create_table :roles_users, :id => false do |t|
      t.references :role, :user
    end
    add_index :roles_users, [:role_id, :user_id ], :unique => true, :name => 'by_role_and_user'
  end

  def down
    drop_table :roles
    drop_table :roles_users
  end
end